library(stockassessment)
load("run/model.RData")
FC<-list()
set.seed(123456)
FC[[length(FC)+1]] <- forecast(fit, fval=c(NA,.195,.178, .178), fscale=c(NA,NA,NA,NA), catchval=c(387,NA,NA,NA), label="MSY approach, Fmsy lower*SSB2023/MSY Btrigger", rec.years=2004:2021, savesim=TRUE)
set.seed(123456)
FC[[length(FC)+1]] <- forecast(fit, fval=c(NA,.195,.2441, .2441), fscale=c(NA,NA,NA,NA), catchval=c(387,NA,NA,NA), label="MSY approach, Fp05 as Fmsy upper*SSB2023/MSY Btrigger", rec.years=2004:2021, savesim=TRUE)
set.seed(123456)
FC[[length(FC)+1]] <- forecast(fit, fval=c(NA,.195,.2441, .2441), fscale=c(NA,NA,NA,NA), catchval=c(387,NA,NA,NA), label="Fmsy *SSB2023/MSY Btrigger", rec.years=2004:2021, savesim=TRUE)
set.seed(123456)
FC[[length(FC)+1]] <- forecast(fit, fval=c(NA,.195,.2441, .2441), fscale=c(NA,NA,NA,NA), catchval=c(387,NA,NA,NA), label="Fmsy  *SSB2023/MSY Btrigger short R sampling", rec.years=2019:2021, savesim=TRUE)
set.seed(123456)
FC[[length(FC)+1]] <- forecast(fit, fval=c(NA,.195,NA, .26), fscale=c(NA,NA,NA,NA), catchval=c(387,NA,839,NA), label="TAC2022*1.2", rec.years=2004:2021, savesim=TRUE)
set.seed(123456)
FC[[length(FC)+1]] <- forecast(fit, fval=c(NA,.195 ,NA, NA), fscale=c(NA,NA,NA,NA), catchval=c(387,NA,0,0), label="zero catch", rec.years=2004:2021, savesim=TRUE)
set.seed(123456)
FC[[length(FC)+1]] <- forecast(fit, fval=c(NA,.195,.315, .315), fscale=c(NA,NA,NA,NA), catchval=c(387,NA,NA,NA), label="other options, Flim", rec.years=2004:2021, savesim=TRUE)
set.seed(123456)
FC[[length(FC)+1]] <- forecast(fit, fval=c(NA,.195,NA,.238), fscale=c(NA,NA,NA,NA), catchval=c(387,NA,NA,NA),nextssb=c(NA,NA, 1850,NA),label="SSB(2024)= Blim", rec.years=2004:2021, savesim=TRUE)
set.seed(123456)
FC[[length(FC)+1]] <- forecast(fit, fval=c(NA,.195,0.195, NA), fscale=c(NA,NA,NA,1), catchval=c(387,NA,NA,NA),label="other options, F=F2021", rec.years=2004:2021, savesim=TRUE)
set.seed(123456)
FC[[length(FC)+1]] <- forecast(fit, fval=c(NA,.195,NA,.238), fscale=c(NA,NA,NA,NA), catchval=c(387,NA,NA,NA),nextssb=c(NA,NA,2600,NA),label="SSB(2024)= Bpa,Btrigger", rec.years=2004:2021, savesim=TRUE)



Blim=1850
above<-function(x){xx<-mean(x[[4]]$ssb>Blim);yr<-x[[4]]$year; round(xx*100,1)}
Pabove<-lapply(FC, above)
names(Pabove)<-lapply(FC, function(x){attr(x,"label")})
Pabove<-as.matrix(unlist(Pabove))
colnames(Pabove)<-paste0("P(SSB",FC[[1]][[4]]$year, " > ",Blim,") in %")


save(FC, Pabove, file="run/forecast.RData")

